<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="MetaModules">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Credentials Domino MetaModule</title>
        
        <link href="../../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../../index.html#18-metamodules/credentials-domino/credentials-domino-metamodule.html">Open topic with navigation</a>
        </p>
        <h1>Credentials Domino MetaModule</h1>
        <p>The Credentials Domino MetaModule enables you to determine how far an attacker can get in a network if they are able to obtain a particular credential.  It is performs an iterative credentials-based attack to identify the attack routes that are possible if  a session is obtained or a credential is captured from a particular host. Its purpose is to help you gauge the impact of a credentials-based attack by reporting  the number of hosts that can be compromised and the number of unique credentials can be captured by leveraging a particular credential.</p>
        <p>In order to run the Credentials Domino MetaModule, the project must have at least one valid login or one open session that you can use as the starting point.  As previously mentioned, the Credentials Domino MetaModule performs an iterative  attack, which means that it repeatedly cycles through the network and attempts to authenticate to each host with a particular credential.   Each iteration represents a single cycle through a network with a different credential.  The Credentials Domino MetaModule continues to run until it  opens a session on every target host or it reaches a termination condition. </p>
        <p>During the first iteration, if you choose to start with a valid login, the Credentials Domino MetaModule immediately tries to use it to authenticate to and open a session on each target host. If the Credentials Domino MetaModule is able successfully authenticate and open a session, it captures the credentials from the host and stores them in the project. Once the MetaModule has successfully opened a session on a host, it will not try the host again. However, if you choose to start with an open session, the MetaModule begins by collecting credentials from the session. Then, it tries each looted credential  until it is able to find a successful login. The MetaModule uses the successful credential to start the next iteration. </p>
        <p>To help you  see how the network is impacted, the MetaModule  includes a specialized report that documents the technical findings and results from the attack. It also presents real-time  results for compromised hosts and captured credentials through the findings window and presents a visualization of the attack patterns that it was able to establish from the target network. </p>
        <h2>Accessing the Credentials Domino MetaModule</h2>
        <p>You can access the Credentials Domino MetaModule from the MetaModules page. To access the MetaModules page, select   <b class="UISelection">Modules &gt;&#160;MetaModules</b> from the Project tab bar. Find the Credentials Domino&#160;MetaModule and click the <b class="UISelection">Launch</b> button. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-overview_337x238.png" style="width: 337;height: 238;" />
        </p>
        <p style="font-weight: normal;">The Credentials Domino MetaModule configuration window appears with the <b class="UISelection">Select Initial Host</b> configuration form displayed. Each configuration step is divided into separate tabs, so you can click on any of the tabs to switch between the different configuration forms. </p>
        <h2>Selecting the Initial&#160;Host for the Credentials Domino MetaModule</h2>
        <p>The first thing you need to do when you configure the Credentials&#160;Domino MetaModule is select the  host that has the login or session you want to use. From the Select Initial Host tab, you can see a list of all hosts in the project that either have valid logins or open sessions. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-initial-host_332x238.png" style="width: 332;height: 238;" />
        </p>
        <p>Select the host that you want the MetaModule to use. The login and session details for the host appears after you select a host.</p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-select-host_335x240.png" style="width: 335;height: 240;" />
        </p>
        <p>Choose the login or session that you want the MetaModule to use to start the attack. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-session_339x243.png" style="width: 339;height: 243;" />
        </p>
        <h2>Defining the Scope for the Credentials Domino MetaModule</h2>
        <p>The scope identifies the hosts that you want the MetaModule to target during the attack. To define the scope, you use the <b class="UISelection">Target addresses</b> and <b class="UISelection">Excluded addresses</b> fields. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-scope_344x246.png" style="width: 344;height: 246;" />
        </p>
        <p>If there are specific hosts that you want to attack, you can enter them in the <b class="UISelection">Target addresses</b> field. You can enter a single address (192.168.1.1), a range (192.168.1.1-192.168.1.100), a CIDR notation (192.168.1.0/24), or a wildcard (192.168.1.*). You must use a newline to separate each entry. If you want to include all hosts in the project, you can leave this field empty. </p>
        <p>If there are specific hosts that you want to exclude from the attack, you can enter them in the <b class="UISelection">Excluded addresses</b> field. Again, you can specify an address range, a CIDR&#160;notation, a comma separated list of host addresses, or a single host address. </p>
        <h2>Designating High Value Hosts for the Credentials Domino MetaModule</h2>
        <p>A High Value Host is a designation that you assign to a host that you want to highlight on the Credentials Domino Findings window and in the Credentials Domino&#160;MetaModule Report. The High Value Host designation helps you quickly identify the impact of a particular stolen credential pair against critical hosts. A High Value Host designation indicates that the host is of significant importance to an organization, and any attack against the host could negatively impact business operations.  For example,  domain controllers and servers that contain sensitive financial information may be considered as High&#160;Value Hosts.</p>
        <p>All High Value Hosts will be highlighted in orange on the Findings window, as shown below in the visualization graph:</p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-hvh-findings_398x230.png" style="width: 398;height: 230;" />
        </p>
        <p>There are a couple of ways you can designate a host as a high value host:</p>
        <ol>
            <li value="1"><b>You can apply host tags</b> - You can apply tags to the hosts that are critical to an organization, which enable you to track, group, and report on hosts according to how they impact an organization. Tags enable you to view and filter hosts at the project level. <br /><br />For example, you may want to tag all accounting servers with a label like, <code class="usertype">accounting</code>. You may also want to want to create and apply criticality tags, such as <code class="usertype">High</code>, <code class="usertype">Medium</code>, and <code class="usertype">Low</code>, to  isolate hosts based on their criticality levels. <br /><br /></li>
            <li value="2"><b>You can specify high value hosts from the Credentials Domino MetaModule</b> - You can also designate high value hosts by their addresses. You can enter an address range, a single address, or a new line separated list of addresses. <br /><br />For example, if you know the IP address for a particular host that is of special interest to you, you can specify it when configuring the scope for the Credentials Domino MetaModule. Use this method if you want to manually define the hosts you want to designate as High Value Hosts and do not want to use tags.  </li>
        </ol>
        <p>After you determine how you want to designate high value hosts, you can specify them from the <b class="UISelection">Scope</b> tab.</p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-high-value-host_385x275.png" style="width: 385;height: 275;" />
        </p>
        <h2>Configuring Payload Settings </h2>
        <p>You can specify the payload that you want the Credentials Domino MetaModule to deliver during the attack. </p>
        <p>To configure the payload settings, you can use the following options, which are located on the <b class="UISelection">Settings</b> tab:</p>
        <ul>
            <li value="1"><b class="UISelection">Payload type</b> - This option determines the type of payload that the MetaModule delivers to the target. You can choose one of the following options: </li>
            <li class="numberedList2" value="2"><b>Meterpreter</b> - This payload provides an advanced interactive shell that provides extensive post-exploitation capabilities that enable you to do things like escalate privileges, dump password hashes, take screenshots, launch and migrate processes, and upload files to the target. Meterpreter also includes command shell capabilities for  basic tasks like adding a user account or running a script.<br /><br />Meterpreter  also dynamically loads itself into an existing process on the target host using a technique called reflective DLL injection, which enables it to reside entirely in memory and remain undetected by intrusion prevention and intrusion detection systems.</li>
            <li class="numberedList2" value="3"><b>Command</b> - This payload provides a command shell that you can use to run single commands on a host  to perform simple tasks like adding a user account or changing a password. A command shell provides limited capabilities, but can be later upgraded to a Meterpreter shell for more options. <br /><br />Unlike Meterpreter, a command shell can start a new process that can be easily detected by intrusion prevention and intrusion detection systems. </li>
            <li value="4"><b class="UISelection">Connection</b> - This option determines how your Metasploit instance connects to the host. You can choose one of the following options:</li>
            <li class="numberedList2" value="5"><b>Auto</b> - This connection type uses a reverse connection when NAT or a firewall is detected; otherwise, it uses bind connection.</li>
            <li class="numberedList2" style="font-weight: normal;" value="6"><b>Bind</b> - This connection type uses a bind connection. You should use this connection type if  there is a direct, unrestricted connection to the target host.</li>
            <li class="numberedList2" value="7"><b>Reverse</b> - This connection type uses a reverse connection. You should select this connection type if the hosts are behind a firewall or a NAT gateway that will prevent requests from your Metasploit instance to the target. </li>
            <li value="8"><b class="UISelection">Listener ports</b> - This option defines the ports that  the listener uses to wait for incoming connections. You can specify a specific port, a comma separated list of ports, or a port range. If you enter a port range, the first available open port is chosen from the range. </li>
            <li style="font-weight: normal;" value="9"><b class="UISelection">Listener host</b> - This option defines the IP address the target host connects back to. This is typically going to be the external IP address of your local machine. If you do not specify a listener host, the MetaModule automatically uses the external IP address of your local machine.</li>
            <li value="10"><b class="UISelection">Clean up sessions</b> - This option enables you to  close all open sessions after the MetaModule finishes. By default, this option is enabled. If you want to keep the sessions open, deselect this option. </li>
        </ul>
        <h2>Setting Termination Conditions for the Credentials Domino MetaModule</h2>
        <p>You can control the number of times that the Credentials Domino MetaModule cycles through a target network by setting iteration and timeout controls. If you do not set iteration or timeout conditions, the Credentials&#160;Domino MetaModule will run until it exhausts all credential and host combinations. Depending on the scope of the attack and the number of credentials captured, the attack can go through a large number of iterations. </p>
        <p>To set termination conditions, you use the following options, which are located on the Settings tab:</p>
        <ul>
            <li value="1"><b class="UISelection">Number of iterations</b> - This option sets a limit on the number of iterations the MetaModule attempts. You can leave the fields blank if you want the MetaModule to continue until it runs out of credentials to try. </li>
            <li value="2"><b class="UISelection">Overall timeout</b> - This option sets a timeout limit for how long the MetaModule can run in its entirety. You can specify the timeout in the following format: HH:MM:SS. You can leave the fields blank to set no timeout limit. </li>
            <li value="3"><b class="UISelection">Service timeout</b> - This option sets a timeout, in seconds, for each target. You can leave the fields blank to set no timeout limit.</li>
        </ul>
        <h2>Including a Generated Credentials Domino MetaModule Report</h2>
        <p>The Credentials Domino MetaModule Report documents the results and technical findings from a credentials-based attack. You can view the report to determine how a validated login or opened session impacted the target network. For more information on the Credentials Domino MetaModule Report, see<MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="../metamodule-reports/credentials-domino-metamodule-report.html" class="online MCXref xref xrefonline">Credentials Domino MetaModule Report</a></MadCap:conditionalText>.</p>
        <p>To include a report the Credentials Domino MetaModule, you just need to enable the report option.</p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-report-option_358x258.png" style="width: 358;height: 258;" />
        </p>
        <p>If you choose to include a report, you can customize the report using any of the following options:</p>
        <ul>
            <li value="1"><b>Format</b> -  The report can be generated as an HTML, PDF, or RTF file. You must select at least one format for the report. </li>
            <li value="2"><b>Name</b> - The report has a default name based on the MetaModule and current date. You can use the default name or provide a custom report name. </li>
            <li value="3"><b>Sections</b> - The report includes the following sections: Cover Page, Project Summary, Findings Summary, Authenticated Services and Hosts Summary Charts, Authenticated Services and Host Details, and Appendix. By default, the report includes all sections. You can deselect any sections that you do not want to include in the report. </li>
            <li value="4"><b>Mask discovered credentials</b> - The report displays all captured credentials in plaintext. If you want to mask the credentials from the report, you must enable this option. </li>
            <li value="5"><b>Include charts</b> - The report includes several charts and graphs that visualize the results from the attack. If you do not want to include visualizations in the report, you must enable this option. </li>
            <li value="6"><b>Excluded addresses</b> - The report includes data for all hosts that you included in the scope. If there are specific hosts whose data you do not want to include in the report, you can list them in this field. </li>
            <li style="font-weight: normal;" value="7"><b>E-mail report</b> - You can e-mail the report after it is generated. To e-mail the report, you must enter a comma separated list of e-mail addresses in this field. <br /><br />Please note that you must already have a local mail server or e-mail relay service set up for Metasploit Pro to use. To define your mail server settings, go to <b class="UISelection">Administration &gt; Global Settings &gt; SMTP Settings</b>.</li>
        </ul>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>You can only generate a MetaModule report from the MetaModule. If you do not choose to include a report when you configure the MetaModule, you will not be able to do so later. </p>
        <h2>Launching the Credentials&#160;Domino MetaModule</h2>
        <p>When you are ready to run the Credentials Domino MetaModule, you can click the <b class="UISelection">Launch</b> button. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-launch_371x266.png" style="width: 371;height: 266;" />
        </p>
        <p>If there are any issues with any of the configuration forms, a red asterisk will appear on the tab to alert you. All configuration forms must be properly configured before you can run the MetaModule.</p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-error_380x272.png" style="width: 380;height: 272;" />
        </p>
        <h2>Understanding the Credentials Domino MetaModule Findings</h2>
        <p>After you launch the Credentials Domino MetaModule, the findings window appears and displays the real-time results and events for the attack.  You  can quickly see the impact of the attack on the target network and identify the possible attack routes. </p>
        <p>To help you navigate the data, the findings window is organized into two major tabs: the Statistics tab and the Task Log tab. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-tabs_379x251.png" style="width: 379;height: 251;" />
        </p>
        <h3>The Statistics Tab</h3>
        <p>The Statistics tab tracks the real-time results for the attack. It displays statistics for the following: </p>
        <ul>
            <li value="1">The total number of iterations that the MetaModule performed</li>
            <li value="2">The total number of captured credentials</li>
            <li value="3">The total number of compromised hosts </li>
        </ul>
        <p>Each statistic is displayed on its own tab. You can click on any of the tabs to view the corresponding details for the statistic.</p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-clickable-tabs_381x252.png" style="width: 381;height: 252;" />
        </p>
        <h4>Viewing the Attack Visualization </h4>
        <p>To help you visualize the attack routes that the MetaModule was able to establish, the findings window includes an attack visualization that graphically shows the relationship and hierarchy between each compromised host on the network. The visualization uses a tree structure and presents each host as a node on the tree. The starting node is the initial host that the MetaModule used to start the attack. </p>
        <p>The attack visualization uses a hierarchical format to connect hosts that are linked to other hosts. The connection between two nodes is created when a credential from one host is used to compromise another host. You can mouseover a node in the attack visualization to highlight the attack route that was used compromise the host.</p>
        <p>Each iteration represents a level on the tree, so the attack visualization can become quite large if the MetaModule performed multiple iterations of the attack. For example, if the MetaModule performed 20 iterations of an attack, there will be 20 levels represented on the attack visualization. If this happens, you can scroll or double-click the tree to zoom in  to view a smaller set of nodes, or you can hover over a specific node to see the details for that host, such as the host name, operating system, credential information, and captured credentials count. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-mouseover_375x251.png" style="width: 375;height: 251;" />
        </p>
        <h4>Viewing the Unique&#160;Credentials&#160;Captured</h4>
        <p>The Credentials Domino MetaModule tracks unique credentials, which are credentials that do not share the same public, private, and realm with other captured credentials. It displays this count on the <b class="UISelection">Unique Credentials Captured</b> tab and  continuously updates the count in real-time. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-unique_382x254.png" style="width: 382;height: 254;" />
        </p>
        <p>For each unique credential captured, the <b class="UISelection">Unique Credentials Captured</b> table shows the public value, private value, realm type, source host IP, source host name, and the number of hosts from which the credential was captured. </p>
        <p>If the credential is a hash or an SSH key, the <b class="UISelection">Private </b>field displays the credential type instead of the private value. You can click on the credential type to view the private value. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-hash_380x250.png" style="width: 380;height: 250;" />
        </p>
        <h4>Viewing Hosts Compromised</h4>
        <p>The Credentials Domino MetaModule tracks hosts on which it was able to open sessions. It displays this count on the Hosts Compromised tab and updates the count in real-time. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-host-compromised_378x250.png" style="width: 378;height: 250;" />
        </p>
        <p>The <b class="UISelection">Hosts Compromised</b> table lists the host IP, host name, operating system, service name, port, public, private, realm type, number of looted credentials, and a link to the session for each compromised host. </p>
        <p>To view a list of the credentials that were captured from the host, you can hover over the credentials count in the Credentials column. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-host-compromised-host-count_383x253.png" style="width: 383;height: 253;" />
        </p>
        <p>To access the details page for an open session, click on the session link in the Session column. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-findings-session-link_387x257.png" style="width: 387;height: 257;" />
        </p>
        <h3>The Task Log Tab</h3>
        <p>The task log tracks the activity for the  MetaModule, such as the host and credential pair combinations that have been attempted and the results of those attempts. The task log also documents any errors or failures that occurred during the&#160;attack and can be used to troubleshoot any issues related to the MetaModule run. This is especially helpful if, for example, the MetaModule has been running for a long time, appears to be hanging, or does not complete. </p>
        <p>
            <img src="../../Resources/Images/metamodules/metamodules-domino-task-log_401x203.png" style="width: 401;height: 203;" />
        </p>
    </body>
</html>